<template>
  <div class="authUser-container auto-height-container" :class="{ 'fullscreen-container': isFullscreen }">
    <vab-query-form>
      <vab-query-form-top-panel>
        <el-form ref="queryRef" inline label-width="70px" :model="queryForm" @submit.prevent>
          <el-form-item label="用户名称" prop="userName">
            <el-input v-model="queryForm.userName" clearable placeholder="请输入用户名称" style="width: 240px" @keyup.enter="handleQuery" />
          </el-form-item>
          <el-form-item v-show="!fold" label="手机号码" prop="phonenumber">
            <el-input
              v-model="queryForm.phonenumber"
              clearable
              placeholder="请输入手机号码"
              style="width: 240px"
              @keyup.enter="handleQuery"
            />
          </el-form-item>
          <el-form-item>
            <el-button icon="Search" :loading="listLoading" native-type="submit" type="primary" @click="handleQuery">查询</el-button>
            <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            <el-button class="hidden-xs-only" text type="primary" @click="handleFold">
              <span v-if="fold">展开</span>
              <span v-else>合并</span>
              <vab-icon class="vab-dropdown" :class="{ 'vab-dropdown-active': fold }" icon="arrow-up-s-line" />
            </el-button>
          </el-form-item>
        </el-form>
      </vab-query-form-top-panel>
      <vab-query-form-left-panel>
        <el-button icon="Plus" type="primary" @click="openSelectUser">添加用户</el-button>
        <el-button icon="CircleClose" type="danger" @click="cancelAuthUserAll">批量取消授权</el-button>
        <el-button icon="Close" plain type="warning" @click="handleClose">关闭</el-button>
      </vab-query-form-left-panel>
      <vab-query-form-right-panel>
        <div class="custom-table-right-tools">
          <el-button @click="handleQuery">
            <vab-icon icon="refresh-line" />
          </el-button>
          <el-button @click="clickFullScreen">
            <vab-icon :icon="isFullscreen ? 'fullscreen-exit-fill' : 'fullscreen-fill'" />
          </el-button>
          <el-popover popper-class="custom-table-checkbox">
            <template #reference>
              <el-button>
                <vab-icon icon="settings-line" />
              </el-button>
            </template>
            <vab-draggable v-model="columns" :animation="600" target=".el-checkbox-group">
              <el-checkbox-group v-model="checkList">
                <el-checkbox
                  v-for="item in columns"
                  :key="item.label"
                  :disabled="item.disableCheck"
                  :label="item.label"
                  :value="item.label"
                >
                  {{ item.label }}
                </el-checkbox>
              </el-checkbox-group>
            </vab-draggable>
          </el-popover>
        </div>
      </vab-query-form-right-panel>
    </vab-query-form>

    <el-table ref="tableRef" v-loading="listLoading" border :data="list" @selection-change="setSelectRows">
      <el-table-column align="center" type="selection" width="50" />

      <el-table-column
        v-for="(item, index) in finallyColumns"
        :key="index"
        align="center"
        :fixed="item.fixed"
        :label="item.label"
        :min-width="item.minWidth || 160"
        :prop="item.prop"
        show-overflow-tooltip
        :sortable="item.sortable"
      >
        <template #default="scope">
          <span v-if="item.label === '状态'">
            <dict-tag :options="sys_normal_disable" :value="scope.row.status" />
          </span>
          <span v-else>{{ scope.row[item.prop] }}</span>
        </template>
      </el-table-column>
      <el-table-column align="center" fixed="right" label="操作" min-width="160">
        <template #default="scope">
          <el-button icon="CircleClose" link type="primary" @click="cancelAuthUser(scope.row)">取消授权</el-button>
        </template>
      </el-table-column>
      <template #empty>
        <el-empty class="vab-data-empty" description="暂无数据" />
      </template>
    </el-table>
    <vab-pagination
      :current-page="queryForm.pageNum"
      :page-size="queryForm.pageSize"
      :total="total"
      @current-change="handleCurrentChange"
      @size-change="handleSizeChange"
    />

    <role-select-user ref="editRef" :role-id="queryForm.roleId" @fetch-data="fetchData" />
  </div>
</template>

<script lang="ts" setup>
import type { TableInstance } from 'element-plus'
import { allocatedUserList, authUserCancel, authUserCancelAll } from '/@/api/roleManagement'
import { useTabsStore } from '/@/store/modules/tabs'

defineOptions({
  name: 'AuthUser',
})

const route = useRoute()
const router = useRouter()
const tabStore = useTabsStore()
const { delVisitedRoute } = tabStore

const { proxy } = getCurrentInstance() as any
const { sys_normal_disable } = proxy.useDict('sys_normal_disable')

const { exit, enter, isFullscreen: _isFullscreen } = useFullscreen()

const isFullscreen = ref<boolean>(false)
const fold = ref<boolean>(true)
const tableRef = ref<TableInstance>()
const editRef = ref<any>(null)
const list = ref<any>([])
const listLoading = ref<boolean>(true)

const total = ref<number>(0)
const selectRows = ref<any>([])
const checkList = ref<any>([])
const queryForm = reactive<any>({
  pageNum: 1,
  pageSize: 10,
  roleId: route.params.roleId,
  userName: undefined,
  phonenumber: undefined,
})

const columns = ref<any>([
  { label: '用户名称', prop: 'userName', minWidth: 160, checked: true },
  { label: '用户昵称', prop: 'nickName', minWidth: 160, checked: true },
  { label: '邮箱', prop: 'email', minWidth: 160, checked: true },
  { label: '手机', prop: 'phonenumber', minWidth: 120, checked: true },
  { label: '状态', prop: 'status', minWidth: 120, checked: true },
  { label: '创建时间', prop: 'createTime', minWidth: 160, checked: true },
])
const finallyColumns = computed(() => columns.value.filter((item: any) => checkList.value.includes(item.label)))

watch(
  _isFullscreen,
  () => {
    if (_isFullscreen.value) isFullscreen.value = true
    else isFullscreen.value = false
  },
  { immediate: true }
)

onActivated(() => {
  tableRef.value?.doLayout()
})

onBeforeMount(() => {
  columns.value.forEach((item: any) => {
    if (item.checked) checkList.value.push(item.label)
  })
  fetchData()
})

/** 点击全屏 */
const clickFullScreen = () => {
  isFullscreen.value = !isFullscreen.value
  isFullscreen.value ? enter() : exit()
}

/** 搜索条件折叠 */
const handleFold = () => {
  fold.value = !fold.value
}

/** 查询授权用户列表 */
const fetchData = async () => {
  listLoading.value = true
  const pp = Object.assign({}, queryForm)
  const { rows, total: _total } = (await allocatedUserList(pp)) as any
  list.value = rows
  total.value = _total
  listLoading.value = false
}

/** 搜索按钮操作 */
function handleQuery() {
  queryForm.pageNum = 1
  fetchData()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm('queryRef')
  handleQuery()
}

const handleSizeChange = (value: number) => {
  queryForm.pageNum = 1
  queryForm.pageSize = value
  fetchData()
}

const handleCurrentChange = (value: number) => {
  queryForm.pageNum = value
  fetchData()
}

const setSelectRows = (value: string) => {
  selectRows.value = value
}

/** 添加用户按钮操作 */
const openSelectUser = () => {
  editRef.value.show()
}

/** 取消授权按钮操作 */
function cancelAuthUser(row: any) {
  $baseConfirm(`确认要取消该用户“${row.userName}”角色吗`, null, async () => {
    authUserCancel({ userId: row.userId, roleId: queryForm.roleId }).then(() => {
      $baseMessage('取消授权成功', 'success', 'hey')
      fetchData()
    })
  })
}

/** 批量取消按钮操作 */
const cancelAuthUserAll = () => {
  if (selectRows.value.length > 0) {
    const ids = selectRows.value.map((item: { userId: any }) => item.userId)
    const roleId = queryForm.roleId
    const uIds = ids.join(',')
    $baseConfirm('您确定要取消选中用户授权数据项吗?', null, async () => {
      authUserCancelAll({ roleId, userIds: uIds }).then(() => {
        $baseMessage('取消授权成功', 'success', 'hey')
        fetchData()
      })
    })
  } else {
    $baseMessage('您未选中任何行', 'warning', 'hey')
  }
}

/** 关闭按钮操作 */
async function handleClose() {
  await delVisitedRoute(route.path)
  router.push({ name: 'RoleManagement' })
}
</script>
